<?php


class RadioactivityDeferredIncidentStorage extends RadioactivityIncidentStorage {

  /**
   * Constructor
   * @param unknown_type $field_info
   */
  public function __construct($field_info) {
    parent::__construct($field_info);
  }

  /**
   * add incident to the deferred storage
   * @entity_energy energy by entity id
   */
  public function addIncident(array $entity_energy) {

    static $time_now = NULL;

    if ($time_now == NULL) {
      $time_now = time();
    }

    foreach ($entity_energy as $entity_id => $energy) {

      db_insert('radioactivity_deferred_storage')
        ->fields(array(
          'entity_type' => $this->entityType,
          'field_name ' => $this->fieldName,
          'bundle ' => $this->bundle,
          'entity_id' => $entity_id,
          'energy' => $energy,
          'emission_time' => $time_now,
        ))
        ->execute();
    }
  }


  /**
   * Process incidents in the deferred queue 
   */
  public function processIncidents() {

    // grab rows from table and push them to fields

    $query = db_select("radioactivity_deferred_storage", "rds")
      ->fields("rds", array("entity_id"))
      ->condition("entity_type", $this->entityType)
      ->condition("bundle", $this->bundle)
      ->condition("field_name", $this->fieldName)
      ->groupBy("rds.entity_type")
      ->groupBy("rds.entity_id");

    $query->addExpression("SUM(rds.energy)", "energy");

    $result = $query->execute();

    $now = time() - 10;

    while ($row = $result->fetch()) {

      $this->updateEnergy($row->entity_id, $row->energy);

    }

    // Flush the processed entries from the db
    db_delete("radioactivity_deferred_storage")
      ->condition("entity_type", $this->entityType)
      ->condition("field_name", $this->fieldName)
      ->condition("bundle", $this->bundle)
      ->execute();


  }





}
